import es
import os
import langlib
import playerlib

# Set the addon info data
info = es.AddonInfo()
info.name = 'NameBan'
info.version = '1.0.0'
info.url = 'http://addons.eventscripts.com/addons/view/nameban'
info.basename = 'nameban'
info.author = 'Freddukes AKA Pro Noob'

# Make Public Variable
es.ServerVar('nameban',info.version,'NameBan Version - Made by Freddukes').makepublic()

myfile = open(str(es.getAddonPath('nameban')).replace('\\','/') + '/filters.txt')
name_dict = {}
for line in filter(lambda x: False if x.startswith('//') else bool(x.replace(' ','')), map(lambda x: x.replace('\n','') ,myfile.readlines())):
    name_dict[' '.join(line.split()[0:-1])] = line.split()[-1]
myfile.close()

dict_options = {
'name_change_type':[1           ,'The type that will change. 1 = Star out the bad part of the name, 2 = change the name completely'],
'new_name_change' :['[Censored]','The new name of the player who has their name changed.'],
'punish_ban_time' :[1440        , 'Amount of minutes to ban a player by']
}

text = lambda x,y=None,z=None: 'Missing Language'

def load():
    global text

    es.dbgmsg(0,'\n*******************************************************')
    es.dbgmsg(0,'NameBan: Protecting your server from nasty names!')
    es.dbgmsg(0,'NameBan: Current Version - %s'%info.version)
    es.dbgmsg(0,'NameBan: Made by Freddukes')
    
    for option in dict_options:
        es.ServerVar(option, dict_options[option][0], dict_options[option][1])

    str_path = es.getAddonPath('nameban') + '/config.cfg'
    if os.path.isfile(str_path):
        es.server.queuecmd('es_xmexec ../addons/eventscripts/nameban/config.cfg')
        es.dbgmsg(0,'NameBan: Successfully Loaded \'config.cfg\'')
    else:
        es.dbgmsg(0,'NameBan: ERROR - No config.cfg found! Ensure it is in ../nameban/')
        
    langpath = es.getAddonPath('nameban') + '/strings.ini'
    if os.path.isfile(langpath):
        text = langlib.Strings(langpath)
        es.dbgmsg(0,'NameBan: Successfully Loaded \'strings.ini\'')
    else:
        es.dbgmsg(0,'NameBan: - ERROR Unable to load strings.ini! Please ensure it is in the ./nameban/ directory.')
    es.dbgmsg(0,'*******************************************************\n')
        
def player_spawn(ev):
    checkFilter(ev['userid'], ev['es_username'])
        
def player_activate(ev):
    checkFilter(ev['userid'], ev['es_username'])
    
def player_changename(ev):
    checkFilter(ev['userid'], ev['newname'])
    
def checkFilter(userid, name):
    name = name.lower()
    for name_filter in name_dict:
        if name_filter in name:
            power = int(name_dict[name_filter]) 
            if power == 1:
                es.server.queuecmd('kickid %s %s'%(userid, text('kicked', lang=playerlib.getPlayer(userid).get("lang"))))
            elif power == 2:
                es.server.queuecmd('banid %s %s'%(es.ServerVar('punish_ban_time'), userid))
                es.server.queuecmd('kickid %s %s'%(userid, text('banned', {'time':str(es.ServerVar('punish_ban_time'))} ,playerlib.getPlayer(userid).get("lang"))))
                es.server.queuecmd('writeid %s'%userid)
            elif power == 3:
                if int(es.ServerVar('name_change_type')) == 1:
                    name = name.replace(name_filter, '*' * len(name_filter))
                    es.cexec(userid, 'name %s'%name)
                else:
                    es.cexec(userid, 'name %s'%es.ServerVar('new_name_change'))  
